# -*- coding: UTF-8 -*-
###########################################################################
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
#
# Action générique
#
#
###########################################################################
from twisted.python import log
from ead2.backend.lib.action import * # import des actions  et types
from ead2.backend.actions import tools
from creole.parsedico import parse_dico
DICO = parse_dico()
#from os import listdir

from glob import glob
from os.path import splitext,basename

# recuperation de la liste des modules virtuels
#modules_list = glob('/etc/vz/conf/*.conf')
#modules_list = [basename(splitext(i)[0]) for i in modules_list]
#modules_list.remove('0')
code, modules_list = tools.command_statusoutput("/usr/sbin/vzlist -a -H -n -o name")
modules_list = modules_list.strip().rstrip().split()

used_templates = ['main', 'form', 'formselect']
# commandes
cmd_list = "/usr/sbin/vzlist -n -H -o name"
cmd_restart = "/usr/bin/virt_ctrl %s restart"
cmd_start = "/usr/bin/virt_ctrl %s start"
cmd_stop = "/usr/bin/virt_ctrl %s stop"

class Virt(Action):
    """ Page """
    user_description = Dict(default={}, doc="description de l'éxécutant", keys=['ip', 'name', 'role'])
    name = "virt" #celui de perm_nomdumodule.ini
    libelle = "Modules virtualisés "
    category = "Système"
    description = "Redémarrer/Arrêter/Démarrer les modules virtuels"

    request = Dict(default={}, doc="arguments de la requete en cours cote frontend",
                        keys=['server', 'action', 'start', 'stop', 'restart'])#server et action sont les clés systématiques

    form_result = Dict(default={}, doc='retour de formulaire', keys=[])

    def execute(self):
        params, self.server_nb = tools.get_request(self.request)
        if params.has_key('start'):
            try:
                # datas: dico utilisé pour la templatisation
                datas = self.start(params['start'][0])
            except Exception, message:
                datas = dict(message=message.message)
            datas['toexec'] = tools.make_js_link(self.server_nb, 'virt', confirm=True)
            return self.send_frag(datas, template='amonecole_virt',
                                templates=used_templates)
        if params.has_key('restart'):
            try:
                # datas: dico utilisé pour la templatisation
                datas = self.restart(params['restart'][0])
            except Exception, message:
                datas = dict(message=message.message)
            datas['toexec'] = tools.make_js_link(self.server_nb, 'virt', confirm=True)
            return self.send_frag(datas, template='amonecole_virt',
                                templates=used_templates)
        if params.has_key('stop'):
            try:
                # datas: dico utilisé pour la templatisation
                datas = self.stop(params['stop'][0])
            except Exception, message:
                datas = dict(message=message.message)
            datas['toexec'] = tools.make_js_link(self.server_nb, 'virt', confirm=True)
            return self.send_frag(datas, template='amonecole_virt',
                                templates=used_templates)

        result = {'titre':self.libelle} # variable renvoyée utilisée dans le template associé
        result.update(self.get_btns())
        result.update(self.get_reload_btn())
        return self.send_all(result, template='amonecole_virt',
                            templates=used_templates)

    def restart(self, module_name):
        if module_name in modules_list:
            a,b = tools.command_statusoutput(cmd_restart % module_name)
            if a:
                raise Exception, "Erreur: une erreur s'est produite au redémarrage de %s : %s " % (module_name, b)
            return dict(message = "Le module %s a redémarré" % module_name)
        else:
            raise Exception, "Ce module est inconnu"

    def stop(self, module_name):
        if module_name in modules_list:
            a,b = tools.command_statusoutput(cmd_stop % module_name)
            if a:
                raise Exception, "Erreur: une erreur s'est produite à l'arrêt de %s : %s " % (module_name, b)
            return dict(message = "Le module %s est arrêté." % module_name)
        else:
            raise Exception, "Ce module est inconnu"

    def start(self, module_name):
        if module_name in modules_list:
            a,b = tools.command_statusoutput(cmd_start % module_name)
            if a:
                raise Exception, "Erreur: une erreur s'est produite au démarrage de %s : %s " % (module_name, b)
            return dict(message = "Le module %s est démarré" % module_name)
        else:
            raise Exception, "Ce module est inconnu"

    def get_btns(self):
        """ renvoie la description pour la mise en forme des boutons de start/stop/restart
        """
        # on liste les modules démarrés
        code, ret_str = tools.command_statusoutput(cmd_list)
#        on_modules = [i.split()[0]for i in ret_str.splitlines()[1:]]
        on_modules = ret_str.strip().rstrip().split()
        module_btns = {}
        for module in modules_list:
            if module in on_modules :
                available_actions = ['stop', 'restart']
                diode = "/image/diode_on.png"
                module_libelle = None
                for key, value in DICO.items():
                    if value == module and key.startswith('id_virt_'):
                        module_libelle = key.split('_')[2]
                if not module_libelle: module_libelle = module
            else:
                available_actions = ["start"]
                diode = "/image/diode_off.png"
                module_libelle = None
                for key, value in DICO.items():
                    if value == module and key.startswith('id_virt_'):
                        module_libelle = key.split('_')[2]
                if not module_libelle: module_libelle = module
                module_libelle = "%s <br />(arrêté)" % module_libelle
            module_btns[module_libelle] = {'btns':[], 'diode':diode}

            for action in available_actions:
                if action == 'start':
                    href = tools.make_js_link(self.server_nb, self.name,
                                            balise='virt_msg', start=module)
                    icone = "image/leftright.png"
                elif action == "restart":
                    href = tools.make_js_link(self.server_nb, self.name,
                                            balise='virt_msg', restart=module)
                    icone = "image/redemarrer.gif"
                elif action == "stop":
                    href = tools.make_js_link(self.server_nb, self.name,
                                            balise='virt_msg', stop=module)
                    icone = "image/arreter.gif"

                title = ''
                libelle = action
                module_btns[module_libelle]['btns'].append(dict(href=href,
                                                title=title,
                                                libelle=libelle,
                                                icone=icone,
                                                _class="simple_link"))
        return dict(btns=module_btns)


    def get_reload_btn(self):
        """
        renvoie les données pour la mise en forme d'un bouton reload
        """
        href = tools.make_js_link(self.server_nb, self.name,
                                    confirm=False)
        title = ""
        libelle = "Recharger<br /> la page"
        icone = ""
        _class = "simple_link"
        return dict(reload_btn=dict(href=href,
                                     title=title,
                                     libelle=libelle,
                                     icone=icone,
                                     _class=_class))

